<?php

/*
* Simple TagCloud plugin
* v. 0.5d
* By Kupo/Watt
* Site pgc-cs.eu
* Add tags to your page :>
* Price Free (You have to leave oryginal footer)
*/

// Plugin hook(s)
$plugins->add_hook('forumdisplay_start', 'stcp_forumdisplay');
$plugins->add_hook('showthread_start', 'stcp_showthread');
$plugins->add_hook('index_start', 'stcp_index');
$plugins->add_hook('newthread_start', 'stcp_showthread_new');
$plugins->add_hook('editpost_start', 'stcp_showthread_edit');
$plugins->add_hook('datahandler_post_insert_thread', 'stcp_topic_new');
$plugins->add_hook('datahandler_post_update_thread', 'stcp_topic_update');
$plugins->add_hook('editpost_deletepost', 'stcp_topic_delete');

if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

function stcp_info()
{
	return array(
		'name'			=> 'Simple TagCloud (beta)',
		'description'	=> 'افزونه ساخت برچسب برای فروم ترجمه MybbIran.com<br /> <a href="../tags.php?insert=2">کلیک کنید تا برای همه موضوع ها برچسب ساخته شود</a><br />',
		'website'		=> 'http://pgc-cs.eu/',
		'author'		=> 'Watt / Kupo',
		'authorsite'	=> 'http://pgc-cs.eu/',
		'version'		=> '0.5d',
		'compatibility' => '14*'
	);
}

function stcp_activate()
{

	global $db;
	
	/* Make new table */
	$db->write_query("CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."stcp` (
	  `id` int(10) NOT NULL auto_increment,
	  `tag_name` text NOT NULL,
	  `tag_amount` int(10) NOT NULL,
	  PRIMARY KEY  (`id`)
		) CHARACTER SET utf8 COLLATE utf8_general_ci; ");
	$db->query("INSERT INTO `".TABLE_PREFIX."stcp` (tag_name, tag_amount) VALUES ('**GLOBAL**', 0)");
	

	$stcp_group = array(
		"gid"			=> "NULL",
		"name"			=> "stcp_settings",
		"title" =>"Simple TagCloud For MyBB",
		"description"	=> "افزونه ساخت برچسب برای فروم ترجمه MybbIran.com",
		"disporder"		=> "3",
		"isdefault"		=> "no",
	);

	$db->insert_query("settinggroups", $stcp_group);
	$gid = $db->insert_id();

	$stcp_setting_1 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_on",
		"title"			=> "روشن کردن پلاگین برچسب ها",
		"description"	=> "پلاگین روشن شود؟",
		"optionscode"	=> "onoff",
		"value"			=> "1",
		"disporder"		=> "1",
		"gid"			=> intval($gid),
	);
	$stcp_setting_2 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_automat",
		"title"			=> "ساختن خودکار برچسب در موضوع",
		"description"	=> "مانند وی بی خودکار برچسب ساخته شود؟",
		"optionscode"	=> "onoff",
		"value"			=> "1",
		"disporder"		=> "2",
		"gid"			=> intval($gid),
	);
	$stcp_setting_3 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_smallwords",
		"title"			=> "برای کلمه های کوچک برچسب نساز",
		"description"	=> "حداقل تعداد کاراکتری که لغت باید داشته باشد، برای اینکه از تمام لغات برچسب ساخته شود عدد 0 را وارد کنید.",
		"optionscode"	=> "text",
		"value"			=> "3",
		"disporder"		=> "3",
		"gid"			=> intval($gid),
	);
	$stcp_setting_4 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_keywords",
		"title"			=> "کلمه های مهم",
		"description"	=> "کلمه های مهم در توصیف سایت خود را وارد کنید. <br />(آن ها را با کاما از هم جدا کنید) پیشنهاد می شود بین 5-10 کلمه وارد کنید.",
		"optionscode"	=> "text",
		"value"			=> "mybb,mybb plugins,info,help me,I love BigMac,whatever",
		"disporder"		=> "4",
		"gid"			=> intval($gid),
	);
	$stcp_setting_5 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_path",
		"title"			=> "مسیر برچسب های شما",
		"description"	=> "مسیر برچسب ها شما (اگر آن را تغییر دهید باید فایل .htaccess را هم ویرایش کنید). <br /> http://www.yoursite.com/<b>tagpath</b>/tag",
		"optionscode"	=> "text",
		"value"			=> "tag",
		"disporder"		=> "5",
		"gid"			=> intval($gid),
	);
	$stcp_setting_6 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_page",
		"title"			=> "برچسب ها در صفحه",
		"description"	=> "چه تعداد برچسب در صفحه نمایش داده شود؟",
		"optionscode"	=> "text",
		"value"			=> "15",
		"disporder"		=> "6",
		"gid"			=> intval($gid),
	);
	$stcp_setting_7 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_roll",
		"title"			=> "نمایش برچسب ها به صورت بسته شده باشد؟",
		"description"	=> "آیا نیاز است که جعبه برچسب ها به صورت بسته شده نمایش داده شود تا در صورت نیار توسط خود کاربر باز شود؟",
		"optionscode"	=> "onoff",
		"value"			=> "0",
		"disporder"		=> "7",
		"gid"			=> intval($gid),
	);
	$stcp_setting_8 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_swear",
		"title"			=> "کلمه های محروم",
		"description"	=> "کلمه هایی که نباید از آن ها برچسب ساخته شود اضافه کنید (آن ها را با کاما از هم جدا کنید)",
		"optionscode"	=> "text",
		"value"			=> "fuck, bullshit, wtf",
		"disporder"		=> "8",
		"gid"			=> intval($gid),
	);
	$stcp_setting_9 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_index_amount",
		"title"			=> "برچسب ها در صفحه اصلی",
		"description"	=> "تعداد برچسب ها در صفحه اصلی",
		"optionscode"	=> "text",
		"value"			=> "100",
		"disporder"		=> "9",
		"gid"			=> intval($gid),
	);
	$stcp_setting_10 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_forumdisplay_amount",
		"title"			=> "برچسب ها در فروم",
		"description"	=> "تعداد برچسب ها در فروم ها",
		"optionscode"	=> "text",
		"value"			=> "30",
		"disporder"		=> "10",
		"gid"			=> intval($gid),
	);
	$stcp_setting_11 = array(
		"sid"			=> "NULL",
		"name"			=> "stcp_size",
		"title"			=> "تعداد برچسب ها",
		"description"	=> "تعداد برچسب ها برای نمایش در صفحه اصلی و صفحه فروم ها (عدد 80 متوسط است)",
		"optionscode"	=> "text",
		"value"			=> "80",
		"disporder"		=> "11",
		"gid"			=> intval($gid),
	);
	
		$db->insert_query("settings", $stcp_setting_1);
		$db->insert_query("settings", $stcp_setting_2);
		$db->insert_query("settings", $stcp_setting_3);
		$db->insert_query("settings", $stcp_setting_4);
		$db->insert_query("settings", $stcp_setting_5);
		$db->insert_query("settings", $stcp_setting_6);
		$db->insert_query("settings", $stcp_setting_7);		
		$db->insert_query("settings", $stcp_setting_8);	
		$db->insert_query("settings", $stcp_setting_9);		
		$db->insert_query("settings", $stcp_setting_10);	
		$db->insert_query("settings", $stcp_setting_11);
		rebuild_settings();
		
	/* ADDING TABLE */		
	if($db->field_exists("tag", "threads"))
	{
		$db->query("ALTER TABLE `".TABLE_PREFIX."threads` DROP `tag`;");
	}
		
	$db->query("ALTER TABLE `".TABLE_PREFIX."threads` ADD `tag` TEXT NOT NULL;");
	
	require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	
	/*TEMPLATE */
		$stcp_temp = array(
		"title"		=> 'stcp',
		"template"	=> $db->escape_string('<html>
<head>
<title>{$word_remade}</title>
<meta name="Robots" content="index, follow" />
<meta name="keywords" content="{$word_remade},{$tag_keywords_s}" />
<meta name="description" content="{$word_remade} - {$mybb->settings[\'bbname\']}. {$similar_tag_desc}" />
	
{$headerinclude}
</head>
<body>
{$header}
<br />
{$pages}
<br />
<br />
{$text}
{$similar_topics}
<table border="0" class="tborder"><tr><td align="center" class="tcat">Simple TagCloud Plugin by Kupo v 0.5d - {$author}</td></tr></table>
<br />
{$pages}
<br />
{$footer}'),
		"sid"		=> "-1",
		"version"	=> "0.1",
		"dateline"	=> "1212366309",
	);
	$db->insert_query("templates", $stcp_temp);
	
	$stcp_edit_insert = array(
		"title"		=> 'stcp-new-edit-thread',
		"template"	=> $db->escape_string('	
<tr>
<td class="trow2" width="20%" ><strong>برچسب ها:</strong></td>
<td class="trow2"><input type="text" class="textbox" id="tag" name="tag" size="40"  value="{$inserted_tag}" tabindex="1" /><div id="tagloading">[برچسب های کلیدی خود را وارد کنید]</div></td>
</tr>'),
		"sid"		=> "-1",
		"version"	=> "0.1",
		"dateline"	=> "1212366306",
	);
	$db->insert_query("templates", $stcp_edit_insert);
	
	$stcp_showthread = array(
		"title"		=> 'stcp-showthread',
		"template"	=> $db->escape_string('<div align="left"><table><tr><td align="left" class="trow2">برچسب ها: {$stcp_thr}</td></tr></table></div>'),
		"sid"		=> "-1",
		"version"	=> "0.1",
		"dateline"	=> "1212366305",
	);
	$db->insert_query("templates", $stcp_showthread);
	
	$stcp_index = array(
		"title"		=> 'stcp-index',
		"template"	=> $db->escape_string('<br /><table border="0" class="tborder"><tr><td class="tcat" colspan="5"><div class="expcolimage"><a href="javascript:void(0);" OnClick="SimpleTagCloudShow();" title="Min/Max-imalize"><img src="images/collapse.gif" id="simple-tc-img" alt="+/-" /></a></div><div><strong>برچسب ها:<br /></div></td></tr><tr><td class="trow2"><div align="left" id="stcp">{$stcp_index}<br /><br /><a href="{$link_forum}{$path}/" title="TagCloud">[More]</a></div></td></tr></table><br />'),
		"sid"		=> "-1",
		"version"	=> "0.1",
		"dateline"	=> "1212366303",
	);
	$db->insert_query("templates", $stcp_index);
	
	$stcp_forumdisplay = array(
		"title"		=> 'stcp-forumdisplay',
		"template"	=> $db->escape_string('<br /><table border="0" class="tborder"><tr><td class="tcat" colspan="5"><div class="expcolimage"><a href="javascript:void(0);" OnClick="SimpleTagCloudShow();" title="Min/Max-imalize"><img src="images/collapse.gif" id="simple-tc-img" alt="+/-" /></a></div><div><strong>برچسب ها:<br /></div></td></tr><tr><td class="trow2"><div align="left" id="stcp">{$stcp_forumdisplay}</div></td></tr></table><br />'),
		"sid"		=> "-1",                
		"version"	=> "0.1",
		"dateline"	=> "1212366301",
	);
	$db->insert_query("templates", $stcp_forumdisplay);
	
	$stcp_tag = array(
		"title"		=> 'stcp-tag',
		"template"	=> $db->escape_string('

<tr><td class="trow1">{$threadlink}</td><td class="trow2">{$tagslink}</td></tr><tr><td class="trow1" colspan="2">
<blockquote>{$message}</blockquote>
</td></tr>

'),
		"sid"		=> "-1",
		"version"	=> "0.1",
		"dateline"	=> "1212366302",
	);
	$db->insert_query("templates", $stcp_tag);
	
	/*END*/
	
	/*Adding tags to index */
	find_replace_templatesets('index', '#{\$footer}#', '{\$stcp_index}{\$footer}');
	
	/*Adding tags to forumdispaly*/
	find_replace_templatesets("forumdisplay", '#{\$usersbrowsing}#', "{\$usersbrowsing}{\$stcp_forumdisplay}");
	
	/*Adding tags to showthread*/
	find_replace_templatesets('showthread', '#{\$pollbox}#', '{\$stcp_thr}{\$pollbox}');
	
	/*Adding tags to newthread*/
	find_replace_templatesets("newthread", '#{\$posticons}#', "{\$new_tags}{\$posticons}");
	find_replace_templatesets("newthread", '#name="subject"#', "name=\"subject\" id=\"subject\" onblur=\"change_tag();\"");
	
	/* Adding to editpost */
	find_replace_templatesets("editpost", '#{\$posticons}#', "{\$edit_tags}{\$posticons}");
	find_replace_templatesets("editpost", '#name="subject"#', "name=\"subject\" id=\"subject\" onblur=\"change_tag();\"");
}

function stcp_deactivate()
{
	require '../inc/adminfunctions_templates.php';
	global $db;
	
	/* Delete table */
	$db->query("DROP TABLE ".TABLE_PREFIX."stcp");
	
	/* DELETING TAGS IN TEMPALTES */
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title = 'stcp'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title = 'stcp-new-edit-thread'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title = 'stcp-showthread'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title = 'stcp-index'");	
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title = 'stcp-forumdisplay'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title = 'stcp-tag'");

	
	find_replace_templatesets("index", '#'.preg_quote('{$stcp_index}').'#', '',0);
	find_replace_templatesets("forumdisplay", '#'.preg_quote('{$stcp_forumdisplay}').'#', '',0);
	find_replace_templatesets("showthread", '#'.preg_quote('{$stcp_thr}').'#', '',0);
	find_replace_templatesets("newthread", '#'.preg_quote('{$new_tags}').'#', '',0);
	find_replace_templatesets("newthread", '#'.preg_quote('id="subject" onblur="change_tag();"').'#', '',0);
	find_replace_templatesets("editpost", '#'.preg_quote('{$edit_tags}').'#', '',0);
	find_replace_templatesets("editpost", '#'.preg_quote('id="subject" onblur="change_tag();"').'#', '',0);
	
	$db->query("ALTER TABLE `".TABLE_PREFIX."threads` DROP `tag`;");
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='stcp_settings'");
	
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_on'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_automat'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_smallwords'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_keywords'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_path'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_page'");	
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_roll'");	
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_swear'");	
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_index_amount'");	
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_forumdisplay_amount'");	
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='stcp_size'");
	
}

function stcp_index()
{
	global $db, $templates, $stcp_index, $mybb, $templates;
	
	/* If it is on */
	if(!$mybb->settings['stcp_on'])
		return false;
		
	/* Keywords, forum link, path loading*/
	
	$tag_keywords = $mybb->settings['stcp_keywords'];		
	//$tag_keywords = str_replace(" ","",$tag_keywords); if you want uncomment it
	$tag_keywords = explode(",",$tag_keywords);
	$tag_liczba_elementow = count($tag_keywords)-1;
	
	$link_forum = $mybb->settings['bburl'];
	$link_forum_leng = strlen($link_forum);
	$link_forum_last = substr($link_forum, $link_forum_leng-1, $link_forum_leng-1);
	if($link_forum_last != "/")
		$link_forum = $link_forum."/";
		
	$path = $mybb->settings['stcp_path'];
	$amount = (int) $mybb->settings['stcp_index_amount'];
	
	/* END */
	$i = 0;
	$index_query = $db->query("SELECT tag FROM `".TABLE_PREFIX."threads` WHERE tag != ''  ORDER BY RAND() LIMIT ".$amount) or die(':<');
	while($fet_index_query = $db->fetch_array($index_query)) // getting a radom selected tags
	{
		$forumindex_tags = explode(",", $fet_index_query['tag']);
		
		foreach( $forumindex_tags as $tag )
		{
			if(!$tag)
				continue 1;				
			$stcp_query = $db->query("SELECT * FROM ".TABLE_PREFIX."stcp WHERE tag_name = '".$tag."'");
			$stcp_fetch = $db->fetch_array($stcp_query);
			if($i > 0)
			{
				if($max_amount < $stcp_fetch['tag_amount'])
					$max_amount = $stcp_fetch['tag_amount'];
			}else{
				$max_amount = $stcp_fetch['tag_amount'];
			}
			
			$array_tag[$i]= $tag.",".$stcp_fetch['tag_amount'];
			$i++;
			
		}		
	}
	if($max_amount == 0)
	{
	$max_amount = 1;
	}
	if($array_tag){
		foreach($array_tag as $tag)
		{
				
			$exploded_tag = explode(",", $tag);
			$tag = $exploded_tag[0];
			$wielkosc = $exploded_tag[1];
			$stcp_size = $mybb->settings['stcp_size'];
			$perc = ($wielkosc * $stcp_size) / $max_amount;
			$perc = $perc - ($wielkosc * $wielkosc);
			$perc = ceil($perc);

			$size = $perc;
			$size = ceil($size);
			if($size < 0)
				$size = 1;
			
			$tag_space = str_replace("-", " ", $tag);
			$tag_aa = ",".$tag_space.",";
			$tag_keeper_aa = ",".$tag_keeper;
				
			if(stristr($tag_keeper_aa , $tag_aa))
				continue 1;
				
			$tag_keeper = $tag.",".$tag_keeper;	

			$stcp_index="<a title=\"".$tag_space." - ".$tag_keywords[rand(0, $tag_liczba_elementow)]."\" href=\"".$link_forum.$path."/".$tag."\"><span style=\"font-size:".$size."px;\">".$tag_space."</span></a>, \n".$stcp_index;
		}
	}
	/* Designing ;p */
	if($stcp_index){
		eval("\$stcp_index = \"".$templates->get("stcp-index")."\";");
		if(!$mybb->settings['stcp_roll']){
			$showJS = '
			<script type="text/javascript">
			var stcpactive = 1;

			function SimpleTagCloudShow()
			{

				if(!stcpactive){
					document.getElementById(\'stcp\').style.display=\'block\';
					stcpactive = 1;
					SimpleTagcloudImg ();
				}else{
					document.getElementById(\'stcp\').style.display=\'none\';
					stcpactive = 0;
					SimpleTagcloudImg ();
				}
			}
			</script>';
			$imgJS = '
			<script type="text/javascript">
			var stcimg = document.getElementById("simple-tc-img");
			function SimpleTagcloudImg ()
			{
				if(stcpactive){
					stcimg.setAttribute("src", "images/collapse.gif");	
					document.getElementById(\'stcp\').style.display=\'block\';				
				}else{
					stcimg.setAttribute("src", "images/collapse_collapsed.gif");
					document.getElementById(\'stcp\').style.display=\'none\';
				}	
			}	
			document.getElementById(\'stcp\').style.display=\'block\';			
			</script>';
		}else{
			$showJS = '
			<script type="text/javascript">
			var stcpactive = 0;

			function SimpleTagCloudShow()
			{

				if(!stcpactive){
					document.getElementById(\'stcp\').style.display=\'block\';
					stcpactive = 1;
					SimpleTagcloudImg ();
				}else{
					document.getElementById(\'stcp\').style.display=\'none\';
					stcpactive = 0;
					SimpleTagcloudImg ();
				}
			}
			</script>';
			$imgJS = '
			<script type="text/javascript">
			var stcimg = document.getElementById("simple-tc-img");
			function SimpleTagcloudImg ()
			{
				if(stcpactive){
					stcimg.setAttribute("src", "images/collapse.gif");	
					document.getElementById(\'stcp\').style.display=\'block\';				
				}else{
					stcimg.setAttribute("src", "images/collapse_collapsed.gif");
					document.getElementById(\'stcp\').style.display=\'none\';
				}	
			}	
			document.getElementById(\'stcp\').style.display=\'none\';	
			stcimg.setAttribute("src", "images/collapse_collapsed.gif");			
			</script>';
		}
		$stcp_index = $showJS."\n".$stcp_index."\n".$imgJS;
	}
}

function stcp_showthread()
{
	global $db, $mybb, $stcp_thr, $templates;
	
	/* If it is on */
	if(!$mybb->settings['stcp_on'])
		return false;
	
	/* Keywords, forum link, path loading*/
	
	$tag_keywords = $mybb->settings['stcp_keywords'];		
	//$tag_keywords = str_replace(" ","",$tag_keywords); if you want uncomment it
	$tag_keywords = explode(",",$tag_keywords);
	$tag_liczba_elementow = count($tag_keywords)-1;
	
	$link_forum = $mybb->settings['bburl'];
	$link_forum_leng = strlen($link_forum);
	$link_forum_last = substr($link_forum, $link_forum_leng-1, $link_forum_leng-1);
	if($link_forum_last != "/")
		$link_forum = $link_forum."/";
		
	$path = $mybb->settings['stcp_path'];
	
	/* END */
	$tid_num = intval($mybb->input['tid']);
	
	$showthread_query = $db->query("SELECT * FROM ".TABLE_PREFIX."threads WHERE tid = '".$tid_num."' AND tag != '' ORDER BY RAND() LIMIT 30");
	while($fet_showthread_query = $db->fetch_array($showthread_query)){
	
		$thread_tags = explode(",", $fet_showthread_query['tag']);
		
		foreach( $thread_tags as $tag )
		{
			if(!$tag)
				continue 1;
			$tag_space = str_replace("-", " ", $tag);
			$stcp_thr="<a title=\"".$tag_space." - ".$tag_keywords[rand(0, $tag_liczba_elementow)]."\" href=\"".$link_forum.$path."/".$tag."\">".$tag_space."</a>, \n".$stcp_thr;
		}
	}
	/* Designing ;d */
	if($stcp_thr)
		eval("\$stcp_thr = \"".$templates->get("stcp-showthread")."\";");
}

function stcp_forumdisplay()
{
	global $thread, $db, $mybb, $stcp_forumdisplay, $templates;
	
	/* If it is on */
	if(!$mybb->settings['stcp_on'])
		return false;

	/* Keywords, forum link, path loading*/
	
	$tag_keywords = $mybb->settings['stcp_keywords'];		
	//$tag_keywords = str_replace(" ","",$tag_keywords); if you want uncomment it
	$tag_keywords = explode(",",$tag_keywords);
	$tag_liczba_elementow = count($tag_keywords)-1;
	
	$link_forum = $mybb->settings['bburl'];
	$link_forum_leng = strlen($link_forum);
	$link_forum_last = substr($link_forum, $link_forum_leng-1, $link_forum_leng-1);
	if($link_forum_last != "/")
		$link_forum = $link_forum."/";
		
	$path = $mybb->settings['stcp_path'];
	$amount = (int) $mybb->settings['stcp_forumdisplay_amount'];
	
	/* END */
	$i = 0;
	$fid_num = intval($mybb->input['fid']);
	$forumdisplay_query = $db->query("SELECT * FROM ".TABLE_PREFIX."threads WHERE fid = '".$fid_num."' AND tag != '' ORDER BY RAND() LIMIT ".$amount);
	while($fet_forumdisplay_query = $db->fetch_array($forumdisplay_query)){
	
		$forum_tags = explode(",", $fet_forumdisplay_query['tag']);
		
		foreach( $forum_tags as $tag )
		{
			if(!$tag)
				continue 1;
				
			$stcp_query = $db->query("SELECT * FROM ".TABLE_PREFIX."stcp WHERE tag_name = '".$tag."'");
			$stcp_fetch = $db->fetch_array($stcp_query);
			if($i > 0)
			{
				if($max_amount < $stcp_fetch['tag_amount'])
					$max_amount = $stcp_fetch['tag_amount'];
			}else{
				$max_amount = $stcp_fetch['tag_amount'];
				
			}
			
			$array_tag[$i]= $tag.",".$stcp_fetch['tag_amount'];
			$i++;
		}		
	}
	if($max_amount == 0)
	{
	$max_amount = 1;
	}
	if($array_tag){
		foreach($array_tag as $tag)
		{
				
			$exploded_tag = explode(",", $tag);
			$tag = $exploded_tag[0];
			$wielkosc = $exploded_tag[1];
			$stcp_size = $mybb->settings['stcp_size'];
			$perc = ($wielkosc * $stcp_size) / $max_amount;
			$perc = $perc - ($wielkosc * $wielkosc);
			$perc = ceil($perc);

			$size = $perc;
			$size = ceil($size);
			if($size < 0)
				$size = 1;
			
			$tag_space = str_replace("-", " ", $tag);
			$tag_aa = ",".$tag_space.",";
			$tag_keeper_aa = ",".$tag_keeper;
				
			if(stristr($tag_keeper_aa , $tag_aa))
				continue 1;
				
			$tag_keeper = $tag.",".$tag_keeper;	

				
			$stcp_forumdisplay="<a title=\"".$tag_space." - ".$tag_keywords[rand(0, $tag_liczba_elementow)]."\" href=\"".$link_forum.$path."/".$tag."\"><span style=\"font-size:".$size."px;\">".$tag_space."</span></a>, \n".$stcp_forumdisplay;
		}
	}
	/* Designing ;> */
	if($stcp_forumdisplay){
		eval("\$stcp_forumdisplay = \"".$templates->get("stcp-forumdisplay")."\";");
		if(!$mybb->settings['stcp_roll']){
			$showJS = '
			<script type="text/javascript">
			var stcpactive = 1;

			function SimpleTagCloudShow()
			{

				if(!stcpactive){
					document.getElementById(\'stcp\').style.display=\'block\';
					stcpactive = 1;
					SimpleTagcloudImg ();
				}else{
					document.getElementById(\'stcp\').style.display=\'none\';
					stcpactive = 0;
					SimpleTagcloudImg ();
				}
			}
			</script>';
			$imgJS = '
			<script type="text/javascript">
			var stcimg = document.getElementById("simple-tc-img");
			function SimpleTagcloudImg ()
			{
				if(stcpactive){
					stcimg.setAttribute("src", "images/collapse.gif");	
					document.getElementById(\'stcp\').style.display=\'block\';				
				}else{
					stcimg.setAttribute("src", "images/collapse_collapsed.gif");
					document.getElementById(\'stcp\').style.display=\'none\';
				}	
			}	
			document.getElementById(\'stcp\').style.display=\'block\';			
			</script>';
		}else{
			$showJS = '
			<script type="text/javascript">
			var stcpactive = 0;

			function SimpleTagCloudShow()
			{

				if(!stcpactive){
					document.getElementById(\'stcp\').style.display=\'block\';
					stcpactive = 1;
					SimpleTagcloudImg ();
				}else{
					document.getElementById(\'stcp\').style.display=\'none\';
					stcpactive = 0;
					SimpleTagcloudImg ();
				}
			}
			</script>';
			$imgJS = '
			<script type="text/javascript">
			var stcimg = document.getElementById("simple-tc-img");
			function SimpleTagcloudImg ()
			{
				if(stcpactive){
					stcimg.setAttribute("src", "images/collapse.gif");	
					document.getElementById(\'stcp\').style.display=\'block\';				
				}else{
					stcimg.setAttribute("src", "images/collapse_collapsed.gif");
					document.getElementById(\'stcp\').style.display=\'none\';
				}	
			}	
			document.getElementById(\'stcp\').style.display=\'none\';	
			stcimg.setAttribute("src", "images/collapse_collapsed.gif");			
			</script>';
		}
		$stcp_forumdisplay = $showJS."\n".$stcp_forumdisplay."\n".$imgJS;
		
	}
}

function stcp_topic_new($new)
{
	//Looked UP in TagCloud Plugin
	//www.mybbturkiye.com/etiket-sistemi-turkce-karakter-destekli-tag-cloud-t-20142.html
	//Sorry for that - I searched and this was the only way I found
	global $db, $mybb;
	
	/* If it is on */
	if(!$mybb->settings['stcp_on'])
		return false;
	
	$tag = $mybb->input['tag'];
	
	/*I'll edit it in nex versions*/
	$tag = str_replace(", ",",", $tag);
	$tag = str_replace(" ,",",", $tag);
	$tag = str_replace("  "," ", $tag);
	$tag = str_replace(" ","-", $tag);
	$tag = str_replace("'","", $tag);
	$tag = str_replace("_","-", $tag);
	$tag = str_replace(";","", $tag);
	$tag = str_replace("|","", $tag);
	$tag = str_replace("/","", $tag);
	$tag = str_replace(":","", $tag);
	$tag = str_replace("*","", $tag);
	$tag = str_replace("<","", $tag);
	$tag = str_replace(">","", $tag);
	$tag = str_replace('"',"", $tag);
	$tag = str_replace("=","-", $tag);
	$tag = str_replace("`","", $tag);
	$tag = str_replace("}","", $tag);
	$tag = str_replace("{","", $tag);
	$tag = str_replace("]","", $tag);
	$tag = str_replace("[","", $tag);
	$tag = str_replace("?", "", $tag);
	$tag = str_replace("%", "", $tag);
	$tag = str_replace("&", "", $tag);	
	$tag = str_replace("(", "", $tag);
	$tag = str_replace(")", "", $tag);
	$tag = str_replace("^", "", $tag);
	$tag = str_replace(",,",',', $tag);

		$explode_tags = explode(",", $tag);
		unset($tag);
		foreach ($explode_tags as $one_tag)
		{
			/** SWEAR EDIT */
			if($mybb->settings['stcp_swear'])
			{
				$swears = str_replace(", ", ",", $mybb->settings['stcp_swear']);
				$swears = explode("," , $swears);
				foreach($swears as $swear)
				{
				if($one_tag == $swear)
					$one_tag = "aaa";
				}
			}
			/* END */
			if(!$one_tag || $one_tag == " ")// If it's empty
				continue 1;
				
			$one_tag_len = strlen($one_tag);
					
			//if($one_tag_len <= $mybb->settings['stcp_smallwords']) doesnt want to work
			if($one_tag_len <= $mybb->settings['stcp_smallwords']){
				$text=$one_tag."<br />".$text;
			}else{
				$s_one_tag = ",".$one_tag;
				if(!strstr($tag, $s_one_tag))
				{
					/* SUM TAGS! */
					$zapytanie = $db->query("SELECT * FROM `".TABLE_PREFIX."stcp` WHERE tag_name='".$one_tag."'");
					if ($db->num_rows($zapytanie))
					{
						while($fetch = $db->fetch_array($zapytanie))
						{
							$amount = (int) $fetch['tag_amount'];
							$amount = $amount + 1;
							$db->query("UPDATE ".TABLE_PREFIX."stcp SET tag_amount = '".$amount."' WHERE tag_name='".$one_tag."'");
						}
					}else{
						$db->query("INSERT INTO `".TABLE_PREFIX."stcp` (tag_name, tag_amount) VALUES ('".$one_tag."', 1)");
					}
					
					$zapytanie = $db->query("SELECT * FROM `".TABLE_PREFIX."stcp` WHERE tag_name='**GLOBAL**'");
					while($fetch = $db->fetch_array($zapytanie))
					{
						$amount = (int) $fetch['tag_amount'];
						$amount = $amount + 1;
						$db->query("UPDATE ".TABLE_PREFIX."stcp SET tag_amount = '".$amount."' WHERE tag_name='**GLOBAL**'");		
					}
					/* AAAA END :P */
					$tag = $tag.",".$one_tag;
				}					
			}
			
			
		}
		$tag_leng = strlen($tag);
		$link_forum_last = substr($tag, $tag_leng-1, $tag_leng-1);
		if($link_forum_last == ",")
		$tag = substr($tag, 0, $tag_leng-1);
	
	$tag = trim($tag);
	$tag = $db->escape_string($tag);
	

	if($tag != "")
	{
		$new->thread_insert_data['tag'] = $tag;
		return $new;
	}	

}
function stcp_topic_update($update)
{
	//Looked UP in TagCloud Plugin
	//www.mybbturkiye.com/etiket-sistemi-turkce-karakter-destekli-tag-cloud-t-20142.html
	//Sorry for that - I searched and this was the only way I found
	global $db, $mybb;

	$tag = $mybb->input['tag'];
	$pid = $mybb->input['pid'];
	
	$zapytanie_tid = $db->query("SELECT tid, pid FROM `".TABLE_PREFIX."posts` WHERE pid='".$pid."'");		 	
	while($fetch_tid = $db->fetch_array($zapytanie_tid))
	{
		$tid = $fetch_tid['tid'];
	}
	
	/* If it is on */
	if(!$mybb->settings['stcp_on'])
		return false;
	
	/*I'll edit it in nex versions*/
	$tag = str_replace(", ",",", $tag);
	$tag = str_replace(" ,",",", $tag);
	$tag = str_replace("  "," ", $tag);
	$tag = str_replace(" ","-", $tag);
	$tag = str_replace("'","", $tag);
	$tag = str_replace("_","-", $tag);
	$tag = str_replace(";","", $tag);
	$tag = str_replace("|","", $tag);
	$tag = str_replace("/","", $tag);
	$tag = str_replace(":","", $tag);
	$tag = str_replace("<","", $tag);
	$tag = str_replace("*","", $tag);
	$tag = str_replace(">","", $tag);
	$tag = str_replace('"',"", $tag);
	$tag = str_replace("=","-", $tag);
	$tag = str_replace("`","", $tag);
	$tag = str_replace("}","", $tag);
	$tag = str_replace("{","", $tag);
	$tag = str_replace("]","", $tag);
	$tag = str_replace("[","", $tag);
	$tag = str_replace("?", "", $tag);
	$tag = str_replace("%", "", $tag);
	$tag = str_replace("&", "", $tag);	
	$tag = str_replace("(", "", $tag);
	$tag = str_replace(")", "", $tag);
	$tag = str_replace("^", "", $tag);
	$tag = str_replace(",,",',', $tag);	
	
	/*******************************************************/
	$zapytanie = $db->query("SELECT tid, tag FROM `".TABLE_PREFIX."threads` WHERE tid='".$tid."'");		 	
	while($fetch = $db->fetch_array($zapytanie))
	{
		$exploded_fetch_tag = explode("," , $fetch['tag']);
		foreach ($exploded_fetch_tag as $tag_to_update)
		{
			$zapytanie = $db->query("SELECT * FROM `".TABLE_PREFIX."stcp` WHERE tag_name='".$tag_to_update."'");
			if ($db->num_rows($zapytanie))
			{
				while($fetch = $db->fetch_array($zapytanie))
				{
					$amount = (int) $fetch['tag_amount'];
					$amount = $amount - 1;
							
					$db->query("UPDATE ".TABLE_PREFIX."stcp SET tag_amount = '".$amount."' WHERE tag_name='".$tag_to_update."'");
				}
			}else{
				$db->query("INSERT INTO `".TABLE_PREFIX."stcp` (tag_name, tag_amount) VALUES ('".$tag_to_update."', 1)");
			}
			$zapytanie_glob = $db->query("SELECT * FROM `".TABLE_PREFIX."stcp` WHERE tag_name='**GLOBAL**'");
			while($fetch_glob = $db->fetch_array($zapytanie_glob))
			{
				$amount = (int) $fetch_glob['tag_amount'];
				$amount = $amount - 1;
				$db->query("UPDATE ".TABLE_PREFIX."stcp SET tag_amount = '".$amount."' WHERE tag_name='**GLOBAL**'");		
			}
		}
	}
	/*******************************************************/
	
		$explode_tags = explode(",", $tag);
		unset($tag);
		foreach ($explode_tags as $one_tag)
		{
			/** SWEAR EDIT */
			if($mybb->settings['stcp_swear'])
			{
				$swears = str_replace(", ", ",", $mybb->settings['stcp_swear']);
				$swears = explode("," , $swears);
				foreach($swears as $swear)
				{
				if($one_tag == $swear)
					$one_tag = "";
				}
			}
			/* END */
			if(!$one_tag || $one_tag == " ")// If it's empty
				continue 1;
			$one_tag_len = strlen($one_tag);			
			//if($one_tag_len <= $mybb->settings['stcp_smallwords']) doesnt want to work			
			if($one_tag_len <= $mybb->settings['stcp_smallwords']){
				$text=$one_tag."<br />".$text;
			}else{
				$s_one_tag = ",".$one_tag;
				if(!strstr($tag, $s_one_tag))
				{
					/* SUM TAGS! */
					$zapytanie = $db->query("SELECT * FROM `".TABLE_PREFIX."stcp` WHERE tag_name='".$one_tag."'");
					if ($db->num_rows($zapytanie))
					{
						while($fetch = $db->fetch_array($zapytanie))
						{
							$amount = (int) $fetch['tag_amount'];
							$amount++;
							$db->query("UPDATE ".TABLE_PREFIX."stcp SET tag_amount = '".$amount."' WHERE tag_name='".$one_tag."'");
						}
					}else{
						$db->query("INSERT INTO `".TABLE_PREFIX."stcp` (tag_name, tag_amount) VALUES ('".$one_tag."', 0)");
					}
					
					$zapytanie = $db->query("SELECT * FROM `".TABLE_PREFIX."stcp` WHERE tag_name='**GLOBAL**'");
					while($fetch = $db->fetch_array($zapytanie))
					{
						$amount = (int) $fetch['tag_amount'];
						$amount = $amount + 1;
						$db->query("UPDATE ".TABLE_PREFIX."stcp SET tag_amount = '".$amount."' WHERE tag_name='**GLOBAL**'");		
					}
					/* AAAA END :P */
					$tag = $tag.",".$one_tag;	
					
				}
			}
			
			
		}
		$tag_leng = strlen($tag);
		$link_forum_last = substr($tag, $tag_leng-1, $tag_leng-1);
		if($link_forum_last == ",")
		$tag = substr($tag, 0, $tag_leng-1);
	
	$tag = trim($tag);
	$tag = $db->escape_string($tag);

	if($tag != "")
	{
		$update->thread_update_data['tag'] = $tag;
		return $update;
	}	
}

function stcp_topic_delete()
{
global $db, $thread, $mybb;

$tid = $thread['tid'];
$pid = $mybb->input['pid'];

	$zapytanie = $db->query("SELECT tid, tag FROM `".TABLE_PREFIX."threads` WHERE tid='".$tid."'");		 	
	while($fetch = $db->fetch_array($zapytanie))
	{		
		if(!$pid == $thread['firstpost'])
			return;
			
		$exploded_fetch_tag = explode("," , $fetch['tag']);
		foreach ($exploded_fetch_tag as $tag_to_update)
		{
			$zapytanie = $db->query("SELECT * FROM `".TABLE_PREFIX."stcp` WHERE tag_name='".$tag_to_update."'");
			if ($db->num_rows($zapytanie))
			{
				while($fetch = $db->fetch_array($zapytanie))
				{
					$amount = (int) $fetch['tag_amount'];
					$amount = $amount - 1;
							
					$db->query("UPDATE ".TABLE_PREFIX."stcp SET tag_amount = '".$amount."' WHERE tag_name='".$tag_to_update."'");
				}
			}else{
				$db->query("INSERT INTO `".TABLE_PREFIX."stcp` (tag_name, tag_amount) VALUES ('".$tag_to_update."', 1)");
			}
			$zapytanie_glob = $db->query("SELECT * FROM `".TABLE_PREFIX."stcp` WHERE tag_name='**GLOBAL**'");
			while($fetch_glob = $db->fetch_array($zapytanie_glob))
			{
				$amount = (int) $fetch_glob['tag_amount'];
				$amount = $amount - 1;
				$db->query("UPDATE ".TABLE_PREFIX."stcp SET tag_amount = '".$amount."' WHERE tag_name='**GLOBAL**'");		
			}
		}
	}
	/*******************************************************/

}

function stcp_showthread_new ()
{
	global $mybb, $db, $new_tags, $thread, $templates;
	
	/* If it is on */
	if(!$mybb->settings['stcp_on'])
		return false;
		 
	if($mybb->input['pid'] == $thread['firstpost'])
	{
		$AJAX = '
		<script type="text/javascript">
		function getXMLHTTPRequest() {
			req = false;
			try {
			req = new XMLHttpRequest();
			} catch(err1) {
			  try {
			  req = new ActiveXObject("Msxml2.XMLHTTP");
			  } catch (err2) {
				try {
				req = new ActiveXObject("Microsoft.XMLHTTP");
				} catch (err3) {
				  req = false;
				}
			  }
			}
			return req;
			}


			var http = getXMLHTTPRequest();

			function change_tag() {

			var myTextField = document.getElementById("subject");
			if(!myTextField.value == ""){
			myRand = parseInt(Math.random()*9996999999121299999);
			http.open("GET", "tags.php" + "?thread=" + myTextField.value + "&rand=" + myRand);
			http.onreadystatechange = function (){
			if(http.readyState == 4 && http.status == 200){
			document.getElementById("tag").value = http.responseText;
			document.getElementById("tagloading").innerHTML = "";
			}else{
			document.getElementById("tagloading").innerHTML = \'<img src="images/spinner.gif" alt="Loading" />\';
			}
			}
			http.send(null);
			}
			}</script>';
			
		eval("\$new_tags = \"".$templates->get("stcp-new-edit-thread")."\";");	
		
		if($mybb->settings['stcp_automat'])
			$new_tags=$AJAX.$new_tags;
	}
}

function stcp_showthread_edit ()
{
	global $mybb, $db, $edit_tags, $thread, $templates;
	
	/* If it is on */
	if(!$mybb->settings['stcp_on'])
		return false;
	
	if($mybb->input['pid'] == $thread['firstpost'])
	{
		$AJAX = '
		<script type="text/javascript">
		function getXMLHTTPRequest() {
			req = false;
			try {
			req = new XMLHttpRequest();
			} catch(err1) {
			  try {
			  req = new ActiveXObject("Msxml2.XMLHTTP");
			  } catch (err2) {
				try {
				req = new ActiveXObject("Microsoft.XMLHTTP");
				} catch (err3) {
				  req = false;
				}
			  }
			}
			return req;
			}


			var http = getXMLHTTPRequest();

			function change_tag() {

			var myTextField = document.getElementById("subject");
			if(!myTextField.value == ""){
			myRand = parseInt(Math.random()*9996999999121299999);
			http.open("GET", "tags.php" + "?thread=" + myTextField.value + "&rand=" + myRand);
			http.onreadystatechange = function (){
			if(http.readyState == 4 && http.status == 200){
			document.getElementById("tag").value = http.responseText;
			document.getElementById("tagloading").innerHTML = "";
			}else{
			document.getElementById("tagloading").innerHTML = \'<img src="images/spinner.gif" alt="Loading" />\';
			}
			}
			http.send(null);
			}
			}</script>';
			
		$inserted_tag = $thread['tag'];
		eval("\$edit_tags = \"".$templates->get("stcp-new-edit-thread")."\";");	
		if($mybb->settings['stcp_automat'])
			$edit_tags = $AJAX.$edit_tags;
	}
}
?>